module IOClasses where

import RIO

import Cli (Options)
import Match.Predicate
import Peer

class HasMailRoot env where
  mailDirRootL :: Lens' env FilePath

class HasMailDeliveryInfo env where
  mailDeliveryCountL :: Lens' env (TVar Integer)
  mailDeliveryPrefixL :: Lens' env (Integer -> String) 

class HasMailSyncConfig env where
  mailSyncDirL :: Lens' env FilePath
  mailSyncPredicatesL :: Lens' env [Predicate]
  mailSyncAcceptableCmdsL :: Lens' env [String]
  mailSyncPeersL :: Lens' env [Peer]
  mailSyncMyCmdL :: Lens' env (String, [String])

class HasOptions env where
  cliOptionsL :: Lens' env Options

